/*
// Created by Lucile on 18/02/2021.
*/

/*!
 * \file personnage.h
 * \brief Character Header File
 * \authors Lucile
 * \version 2
 * \date 25/02/2021
 *
 * Character structure and functions definition.
 *
 */

#ifndef GAME_INSA_PROJECT_PERSONNAGE_H
#define GAME_INSA_PROJECT_PERSONNAGE_H


/*!
 * \struct Personnage
 * \brief Character structure
 */

typedef enum {
    STAY,
    UPP,
    DOWNN,
    LEFTT,
    RIGHTT,
}Direction_hero;



typedef struct {
    Direction_hero direction_personnage;
    int index_image;
} Animation;


typedef enum {
    WIN,
    LOSE,
    PLAYING
} Result;

typedef struct {
    int x_pers; /**< Position : x high-left point */
    int y_pers; /**< Position : y high-left point */
    int long_pers; /**< Size : length */
    int larg_pers; /**< Size : width */
	int x_hr; 	/**< Position : x high-right point */
	int y_hr; 	/**< Position : y high-right point */
	int x_ll; 	/**< Position : x low-left point */
	int y_ll; 	/**< Position : y low-left point */
	int x_lr; 	/**< Position : x low-right point */
	int y_lr;	/**< Position : y low-right point */
    int speed_pers; /**< Character speed */
    int life; /**< Life number */
    Result result;
    Animation animation;      /**< {UP,DOWN,LEFT<RIGHT} and {} */
    Direction_hero last_direction;
	int score;
	int DS_took;
}Personnage;

void init_pers(Personnage * character, int x, int y, int length, int width, int speed);
void calcul_points_pers(Personnage * character);





#endif /*GAME_INSA_PROJECT_PERSONNAGE_H*/
