#include <stdio.h>
#include <stdlib.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_mixer.h>
#include "personnage.h"
#include "GAME.h"
#include "move.h"
#include "timer.h"
#include "window.h"


int main(int argc, char* args[])
{

    /*=======================================*\
    ||                                       ||
    ||             INIT SDL                  ||
    ||                                       ||
    \*=======================================*/

	//Init SDL soft with timer
    if ( SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER) != 0)
    {
        printf("Cannot init SDL GAME, Error : %s\n", SDL_GetError());
        return 1;
    }

    // create a new window
    SDL_Window * window = SDL_CreateWindow("INSA : Exam Wars",SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED,WINDOW_WIDTH+2,WINDOW_HEIGHT+2,0);
    if (!window)
    {
        printf("Cannot create new window: %s\n", SDL_GetError());
        SDL_Quit();
        return 1;
    }

    // create a new renderer for graphic sofware
    Uint32 render_flags = SDL_RENDERER_ACCELERATED;
    SDL_Renderer* renderer = SDL_CreateRenderer(window, -1, render_flags);
    if (!renderer)
    {
        printf("Cannot create renderer: %s\n", SDL_GetError());
        SDL_DestroyWindow(window);
        SDL_Quit();
        return 1;
    }

	
	
				

    /*=======================================*\
    ||                                       ||
    ||            INIT GAME's FLAGS          ||
    ||                                       ||
    \*=======================================*/

    //FLAG close_request for program
    int close_request = 0;




    /*=======================================*\
    ||                                       ||
    ||            INIT GAME's ELEMENTS       ||
    ||             AND CHARACTERS            ||
    ||                                       ||
    \*=======================================*/

	//-----------------TIMER--------------------//
	//create a time_remaining variable to calcul point  
	
	int time_remaining=0;

    //-----------------HERO--------------------//
	//create a Personnage "hero" 
	Personnage hero;
	
	hero.life = 3;
    
	hero.score = 0;
	

    //-----------------WINDOW_PLAY--------------------//

    //create new window play containts level, time and id of the current window
	Window window_play;
	init_window(&window_play,-1,-1,INTRO_PAGE);    // init at the window of intro

	
	//-------------DISPLAY FONT AND TEXT-----------//
	TTF_Init();


        /*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*\
        |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
        |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              GAME LOOP                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
        |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
        \*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/


    while (!close_request)
    {

        switch (window_play.id_window) {    /*Orientation => choose what window to display and to contact with

                                    /*=======================================*\
                                    ||                                       ||
                                    ||              PAGE INTRO               ||
                                    ||                                       ||
                                    \*=======================================*/

            case INTRO_PAGE :
            {
                intro_page(window,renderer,&window_play,&close_request);
                break;
            }



                                    /*=======================================*\
                                    ||                                       ||
                                    ||       PLAYING PAGE WITH LEVELS        ||
                                    ||                                       ||
                                    \*=======================================*/

            case LEVEL:
            {
				switch(window_play.level){
					case 1:
						show_image_in_time(renderer,window,"../ressource/niveau.png",2000);
						level_1(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 2:
						show_image_in_time(renderer,window,"../ressource/niveau_2.jpeg",2000);
						level_2(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 3:
						show_image_in_time(renderer,window,"../ressource/niveau_3.jpeg",2000);
						level_3(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 4:
						show_image_in_time(renderer,window,"../ressource/niveau_4.jpeg",2000);
						level_4(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 5:
						show_image_in_time(renderer,window,"../ressource/niveau_5.jpeg",2000);
						level_5(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 6:
						show_image_in_time(renderer,window,"../ressource/niveau_6.jpeg",2000);
						level_6(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;			
					case 7:
						show_image_in_time(renderer,window,"../ressource/niveau_7.jpeg",2000);
						level_7(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 8:
						show_image_in_time(renderer,window,"../ressource/niveau_8.jpeg",2000);
						level_8(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 9:
						show_image_in_time(renderer,window,"../ressource/niveau_9.jpeg",2000);
						level_9(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;
					case 10:
						show_image_in_time(renderer,window,"../ressource/niveau_final.jpeg",2000);
						level_10(renderer,window,&hero,&window_play,&close_request,&time_remaining);
						break;	
				}
               
                break;
            }



									/*=======================================*\
									||                                       ||
									||               WIN PAGE                ||
									||                                       ||
									\*=======================================*/

            case WIN_PAGE :
            {
               win_page(window,renderer,&window_play,&hero, &close_request, &time_remaining);
                break;
            }
			


									/*=======================================*\
									||                                       ||
									||               FAIL PAGE                ||
									||                                       ||
									\*=======================================*/

            case FAIL_PAGE :
            {
                lose_page(window,renderer,&window_play,&hero, &close_request, &time_remaining);
                break;
            }

        }
    }


    /*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*\
    |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
    |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%          AVENGERS: END GAME           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
    |%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|
    \*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(window);
	Mix_CloseAudio();
    TTF_Quit();
    SDL_Quit();

    return 0;
}
