/*
// Created by Tiny on 5/6/2021.
*/

#include "window.h"
#include "prof.h"
#include "DS.h"
#include "map.h"
#include "GAME.h"
#include "move.h"
#include "timer.h"
#include <time.h>
#include <stdio.h>
void level_3(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining){
	    //-----------------INIT MUSIC--------------------//
	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	Mix_Music *background_music = Mix_LoadMUS("../ressource/sound/one_0.mp3");
	Mix_Music *touch_DS = Mix_LoadMUS("../ressource/sound/touch_DS.wav");
	Mix_Music *life_lost = Mix_LoadMUS("../ressource/sound/death.wav");
	
	

	//-----------------HERO--------------------//	
	//Create a texture and a rect for hero
	SDL_Rect hero_rect;
	SDL_Texture ** container_textures_hero = (SDL_Texture **) calloc(16,sizeof(SDL_Texture*));
	
	//init hero and query its texture
    init_pers(hero,3,480,25,28,SPEED);
	load_hero_textures(renderer,container_textures_hero);
    SDL_QueryTexture(container_textures_hero[0], NULL, NULL, &hero_rect.w, &hero_rect.h);
	hero_rect.w =  28;
    hero_rect.h =  25;
    hero_rect.x =  3;
    hero_rect.y =  480;
	
	 //FLAG FOR DIE, LEVELUP
	int DIE_FLAG=0;
	int LEVELUP_FLAG=0;

				
				
	//-----------------TEACHER 1--------------------//

	//create a Prof "teacher" and its texture, SDL rect
	Prof teacher;
	SDL_Rect teacher_rect;
	SDL_Texture ** container_textures_teacher = (SDL_Texture **) calloc(32,sizeof(SDL_Texture*));
	
	//init teacher and query its texture
    init_prof(&teacher,350,380,30,40,SPEED);
	load_teacher_textures(renderer,container_textures_teacher);
	SDL_QueryTexture(container_textures_teacher[0], NULL, NULL, &teacher_rect.w, &teacher_rect.h);
	teacher_rect.w =  teacher.larg_prof;
    teacher_rect.h =  teacher.long_prof;
    teacher_rect.x =  teacher.x_prof;
    teacher_rect.y =  teacher.y_prof;
				
	//direction random of teacher
	int direction_teacher;
	
	
	//-----------------TEACHER 2--------------------//

	//create a Prof "teacher" and its texture, SDL rect
	Prof teacher2;
	SDL_Rect teacher_rect2;
	SDL_Texture ** container_textures_teacher2 = (SDL_Texture **) calloc(32,sizeof(SDL_Texture*));
	
	//init teacher and query its texture
    init_prof(&teacher2,40,250,30,40,SPEED);
	load_teacher_textures(renderer,container_textures_teacher2);
	SDL_QueryTexture(container_textures_teacher2[0], NULL, NULL, &teacher_rect2.w, &teacher_rect2.h);
	teacher_rect2.w =  teacher2.larg_prof;
    teacher_rect2.h =  teacher2.long_prof;
    teacher_rect2.x =  teacher2.x_prof;
    teacher_rect2.y =  teacher2.y_prof;
				
	//direction random of teacher
	int direction_teacher2;

	//-----------------EXAMS--------------------//

	//Create a DS "exam" and query its texture
	DS exam;
	srand(time(0));
	init_DS(&exam,2 + rand() % 29,"../ressource/DS.png");
	SDL_Rect exam_rect;
	SDL_Texture * texture_exam = query_exam(&exam, &exam_rect, renderer, window);

	//-----------------HEARTS--------------------//

	//Create an image of 1,2 and 3 heart for life and query their texture

	SDL_Texture *texture_1heart;
	SDL_Rect heart1_rect;
	texture_1heart = query_heart(&heart1_rect, renderer, window, "../ressource/1heart.png");

	SDL_Texture *texture_2heart;
	SDL_Rect heart2_rect;
	texture_2heart = query_heart(&heart2_rect, renderer, window, "../ressource/2heart.png");

	SDL_Texture *texture_3heart;
	SDL_Rect heart3_rect;
	texture_3heart = query_heart(&heart3_rect, renderer, window, "../ressource/3heart.png");

				
	//flag to say that the game is beginning => take a random direction for teacher
	int first=1;
				
				
	/*=======================================*\
	||                                       ||
	||              TIMER                    ||
	||                                       ||
	\*=======================================*/

	//textur and rect of timer => Init and query in the game !!!
	SDL_Rect timer_rect;
	timer_rect.x = 580;  //controls the rect's x coordinate
    timer_rect.y = 5; // controls the rect's y coordinte
    timer_rect.w = 40; // controls the width of the rect
    timer_rect.h = 30; // controls the height of the rect
	SDL_Texture ** container_timer = (SDL_Texture **) calloc(window_play->time+1,sizeof(SDL_Texture*));
	load_timer_textures(renderer,container_timer,window_play->time);			
    init_timer();
	

	//-----------------MAP--------------------//

	//Create the Map and query its texture
	MAP map_game;
	SDL_Texture * texture_map = query_map(&map_game, renderer, window);

               
				
	//create a process events for this playing page
    SDL_Event event_playing_page;			
			
    //Start playing background music
    Mix_PlayMusic(background_music,0);

				

                //-------LOOP PLAYING PAGE --------//

                while(hero->result==PLAYING){


                    //-------HERO's PROCESS--------//

                    //test key up-down-left-right
                    test_event_hero(hero,&event_playing_page,close_request);

                    //move the hero
                    move_hero_2_teacher(hero,&hero_rect,&teacher,&teacher2,&exam,&map_game,close_request,&DIE_FLAG,&LEVELUP_FLAG);

                    //-------TIMER PROCESS--------//
                    timer_countdown(hero, window_play->time, time_remaining);
                    

                    //-------TEACHERS PROCESS--------//
		
                    //move the teacher
                    //at the beginning, choose a random direction, else move the teacher
                    if(first==1){
                        srand(time(0));
                        direction_teacher = rand()%4;
						direction_teacher2 = rand()%4;
                        first=0;
                    }
                    else {
						prof_move(&teacher, &direction_teacher, &teacher_rect, &map_game, &exam);
						prof_move(&teacher2, &direction_teacher2, &teacher_rect2, &map_game, &exam);
					}
							
					
					
					
                    //-------SDL DISPLAY PROCESS--------//

                    // clear the window befor display new things
                    SDL_RenderClear(renderer);

                    // copy the images to the renderer
					
                    SDL_RenderCopy(renderer, texture_map, NULL, NULL);
                    copy_hero(hero, &hero_rect, renderer, container_textures_hero);
                    copy_teacher(&teacher, &teacher_rect, renderer, container_textures_teacher);
					copy_teacher(&teacher2, &teacher_rect2, renderer, container_textures_teacher2);
                    SDL_RenderCopy(renderer, texture_exam, NULL, &exam_rect);
					SDL_RenderCopy(renderer, container_timer[*time_remaining], NULL, &timer_rect);


                    //copy heart's image to renderer following hero's life

                    switch (hero->life) {
                        case 1:
                            SDL_RenderCopy(renderer, texture_1heart, NULL, &heart1_rect);
                            break;
                        case 2:
                            SDL_RenderCopy(renderer, texture_2heart, NULL, &heart1_rect);
                            break;
                        case 3:
                            SDL_RenderCopy(renderer, texture_3heart, NULL, &heart2_rect);
                            break;

                    }


                    // display
                    SDL_RenderPresent(renderer);


                    //-------FLAG PROCESS--------//

                    if(DIE_FLAG){        //touch the teacher or timing out

                        //case hero's life = 2 and 3
                        if(hero->life>1){

                            //reset teacher and hero position
                            hero->x_pers = 3;
                            hero->y_pers = 480;
							teacher.x_prof = 350;
                            teacher.y_prof = 380;
							teacher2.x_prof = 40;
                            teacher2.y_prof = 250;
							
                            //decrement hero's life and play the sound effect
                            Mix_PlayMusic(life_lost,0);
							SDL_Delay(500);
                            hero->life--;

                            //show the image of losing life
                            show_image_in_time(renderer,window,"../ressource/lose_heart.png",500);
                        }

                        //case out of life
                        else {
                            hero->result=LOSE;
                        }

                        //reset the die's flag and restart the music
                        DIE_FLAG=0;
                        Mix_PlayMusic(background_music,0);
                    }


                    if(LEVELUP_FLAG)          //when touch the exam
                    {
                        //increment exam took and play the sound effect
                        Mix_PlayMusic(touch_DS,0);

                        hero->DS_took++;
						
						free_Textures(container_timer, window_play->time);
						//set window play id to "LEVEL", level 1, time = 30
                        init_window(window_play,4,15,LEVEL);
						
						show_image_in_time(renderer,window,"../ressource/LEVELUP.png",500);
						
						SDL_Delay(2000);
						
                        break;
                    }

                    //-------- Check hero's result--------//

                    
                    if(hero->result==LOSE){
						free_Textures(container_timer, window_play->time);
                        init_window(window_play,-1,-1,FAIL_PAGE);
                        break;
                    }

                    // wait 17ms before new loop
                    SDL_Delay(17);
                }

    //-------------------How many point this level ???-------------//            
	SDL_Delay(50);
	calculer_score(hero,*time_remaining,window_play);
	
	
	//-------------------Destroy Everything-------------//
    Mix_FreeMusic(touch_DS);
    Mix_FreeMusic(life_lost);
	Mix_FreeMusic(background_music);
	free_map(&map_game);
	free_DS(&exam);
	free_Textures(container_textures_hero, 15);
	free_Textures(container_textures_teacher, 15);
	free_Textures(container_textures_teacher2, 15);
    SDL_DestroyTexture(texture_map);
    SDL_DestroyTexture(texture_1heart);
    SDL_DestroyTexture(texture_2heart);
    SDL_DestroyTexture(texture_3heart);
    SDL_DestroyTexture(texture_exam);
	SDL_RenderClear(renderer);

}