/*
// Created by Tiny on 5/6/2021.
*/

#include "window.h"
#include "button.h"
#include "GAME.h"
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_mixer.h>
void intro_page(SDL_Window * window, SDL_Renderer * renderer,Window * window_play, int *close_request){
	
	
	//-----------------INIT MUSIC--------------------//
    Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	Mix_Music *intro_music = Mix_LoadMUS("../ressource/sound/music.mp3");	
	Mix_Music *click = Mix_LoadMUS("../ressource/sound/click.mp3");	


	//-----------------INIT Button and mouse--------------------//
    Button button_start_game;
	
    init_button(&button_start_game,440,556,191,68);

    int mouseX, mouseY;

    


    //load and show the image of intro page
    SDL_Texture *texture_intro_page = IMG_LoadTexture(renderer,"../ressource/gameinstruction.png");
    SDL_RenderCopy(renderer, texture_intro_page, NULL, NULL);
    SDL_RenderPresent(renderer);


    //create process events for start game
    SDL_Event event_button_start_game;

    //Start playing intro music
    Mix_PlayMusic(intro_music,0);

    //-------LOOP INTRO PAGE FOR WAITING BUTTON CLICK--------//

    while(window_play->id_window==INTRO_PAGE){

        //when dectection of new event
        while (SDL_PollEvent(&event_button_start_game))
        {
            //What type of event ?
            switch (event_button_start_game.type)
            {
                case SDL_QUIT:      //QUIT
                    *close_request = 1;            //set the close's flag
                    window_play->id_window=-1;     //for get out of window play 's orientation
                    break;


                case SDL_MOUSEBUTTONDOWN:     //MOUSE BUTTON CLICK
                    if(event_button_start_game.button.button == SDL_BUTTON_LEFT){

                        //get the current position of mouse
                        SDL_GetMouseState(&mouseX,&mouseY);

                        if(clicked(mouseX,mouseY,&button_start_game)){    //check button clicked


							Mix_PlayMusic(click,0);

                            button_start_game.state=0;

                            //change id window play to "LEVEL", set level = 1, time = 30
                            init_window(window_play,1,30,LEVEL);

                        }
                    }

            }
        }
    }

    //Destroy the image, prepare for level 1 => show image of level 1's presentation
    SDL_DestroyTexture(texture_intro_page);

    //Free Intro Music
    Mix_FreeMusic(intro_music);
	
	Mix_FreeMusic(click);
}

void win_page(SDL_Window * window, SDL_Renderer * renderer,Window * window_play, Personnage * hero, int *close_request, int *time_remaining){
	
	//-----------------INIT and PLAY VICTORY MUSIC--------------------//
	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	Mix_Music *victory  = Mix_LoadMUS("../ressource/sound/victory.mp3");    
	Mix_Music *click = Mix_LoadMUS("../ressource/sound/click.mp3");	
	
	
	
	Mix_PlayMusic(victory,0);
	
	//-----------------INIT Button and Mouse--------------------//
    Button button_replay_win;
    init_button(&button_replay_win,225,580,262,67);
    //position of mouse for click
    int mouseX, mouseY;

    //-----------------GAME's-SCORE--------------------//

    //texture for holding the game's score => no init or query now
    SDL_Texture * texture_score;
    SDL_Rect score_rect;
    //game's score variable
    int score=0;
	//get and query the score following life, exam and the time remaining
    score = calculer_score(hero,*time_remaining,window_play);
    texture_score = query_score(renderer,&score_rect,window, &score);

	
	
	//-----------------Texture for lose page image--------------------//
    SDL_Texture *texture_win_page = IMG_LoadTexture(renderer,"../ressource/win.jpeg");
	


    //display win page image and score
    SDL_RenderCopy(renderer, texture_win_page, NULL, NULL);
    SDL_RenderCopy(renderer, texture_score, NULL, &score_rect);
    SDL_RenderPresent(renderer);

    //create a process events for this playing page
    SDL_Event event__win_game;

    //-------LOOP INTRO PAGE FOR WAITING BUTTON CLICK--------//

    while(window_play->id_window==WIN_PAGE){

        //when dectection of new event
        while (SDL_PollEvent(&event__win_game))
        {
            //what type of event ?
            switch (event__win_game.type)
            {
                case SDL_QUIT:              // QUIT
                    *close_request = 1;            //set the close flag
                    window_play->id_window=-1;     //for get out of window play 's orientation
                    break;
                case SDL_MOUSEBUTTONDOWN:     //MOUSE BUTTON CLICK
                    if(event__win_game.button.button == SDL_BUTTON_LEFT){

                        //get the current position of mouse
                        SDL_GetMouseState(&mouseX,&mouseY);

                        if(clicked(mouseX,mouseY,&button_replay_win)){ //check button clicked

							Mix_PlayMusic(click,0);
							
                            button_replay_win.state=0;

                            //set window play id to "LEVEL", level 1, time = 30
                            init_window(window_play,1,30,LEVEL);
							
							hero->life = 3;
							
							hero->score = 0;
                        
							hero->DS_took = 0;
                        }
                    }

            }
        }
    }
    SDL_DestroyTexture(texture_win_page);
    SDL_DestroyTexture(texture_score);
	Mix_FreeMusic(victory);
    Mix_FreeMusic(click);
}

void lose_page(SDL_Window * window, SDL_Renderer * renderer,Window * window_play, Personnage * hero, int *close_request, int *time_remaining){
	
	//-----------------INIT and play Lose MUSIC--------------------//
	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	Mix_Music *death  = Mix_LoadMUS("../ressource/sound/lost.wav");
	Mix_Music *click = Mix_LoadMUS("../ressource/sound/click.mp3");	
	
	
	Mix_PlayMusic(death,0);
	
	
	//-----------------INIT Button and Mouse--------------------//
    Button button_replay_lose;
    init_button(&button_replay_lose,225,560,262,67);
	//position of mouse for click
    int mouseX, mouseY;
	
	
	//-----------------Texture for lose page image--------------------//
	SDL_Texture *texture_lose_page = IMG_LoadTexture(renderer,"../ressource/lose.jpeg");	
	
	//-----------------GAME's-SCORE--------------------//

    //texture for holding the game's score => no init or query now
    SDL_Texture * texture_score;
    SDL_Rect score_rect;
    int score =0;
    
    //get the score following life, exam and the time remaining
    score = calculer_score(hero,*time_remaining,window_play);
    texture_score = query_score(renderer,&score_rect,window, &score);

    //display fail page image and score
    SDL_RenderCopy(renderer, texture_lose_page, NULL, NULL);
    SDL_RenderCopy(renderer, texture_score, NULL, &score_rect);
    SDL_RenderPresent(renderer);


    // process events
    SDL_Event event_button_replay_lose_game;

    //-------LOOP INTRO PAGE FOR WAITING BUTTON CLICK--------//
    while(window_play->id_window==FAIL_PAGE){

        while (SDL_PollEvent(&event_button_replay_lose_game))
        {
            switch (event_button_replay_lose_game.type)
            {
                case SDL_QUIT:                  //quit
                    *close_request = 1;            //set the close's flag
                    window_play->id_window=-1;     //for get out of window play 's orientation
                    break;
                case SDL_MOUSEBUTTONDOWN:     //MOUSE BUTTON CLICK
                    if(event_button_replay_lose_game.button.button == SDL_BUTTON_LEFT){

                        //get the current position of mouse
                        SDL_GetMouseState(&mouseX,&mouseY);


                        if(clicked(mouseX,mouseY,&button_replay_lose)){    //check button clicked

							Mix_PlayMusic(click,0);

                            button_replay_lose.state=0;

                            //set window play id to "LEVEL", level 1, time = 30
                            init_window(window_play,1,30,LEVEL);

                            hero->life = 3;
							
							hero->score = 0;
							
							hero->DS_took = 0;
                        }
                    }

            }
        }
    }
    SDL_DestroyTexture(texture_lose_page);
	SDL_DestroyTexture(texture_score);
	Mix_FreeMusic(death);
    Mix_FreeMusic(click);
}